<template>
  <v-dialog
    v-if="size === 'compact'"
    v-model="dialog"
    :scrim="false"
    :absolute="true"
    class="top-10"
    :close-on-content-click="false"
    :contained="true"
  >
    <template #activator="{ props }">
      <svn-pro-icon-button
        v-bind="props"
        :icon="icon"
        variant="text"
        :color="pickerType === 'color' ? editor.getAttributes('textStyle')?.color ? 'primary' : 'onSurfaceVariant' : editor.getAttributes('highlight')?.color ? 'primary' : 'onSurfaceVariant'"
      />
    </template>

    <template #default>
      <div class="w-full h-full">
        <v-color-picker
          v-model="color"
          hide-inputs
          show-swatches
          @update:model-value="handleColorChanged"
        />
      </div>
    </template>
  </v-dialog>

  <Popover v-else class="relative items-center justify-center translate-y-0.5">
    <PopoverButton>
      <svn-pro-icon-button
        :icon="icon"
        variant="text"
        :color="pickerType === 'color' ? editor.getAttributes('textStyle')?.color ? 'primary' : 'onSurfaceVariant' : editor.getAttributes('highlight')?.color ? 'primary' : 'onSurfaceVariant'"
      />
    </PopoverButton>

    <PopoverPanel class="absolute z-10">
      <v-color-picker
        v-model="color"
        hide-inputs
        show-swatches
        @update:model-value="handleColorChanged"
      />
      <!-- <div class="rounded-[8px] flex flex-col items-center gap-2 border border-light-grey shadow bg-white p-2">
        <hex-color-picker :color="color" @color-changed="handleColorChanged" class="colorPicker"></hex-color-picker>

        <div class="flex items-center gap-1">
          <input
            v-model="colorInput"
            type="text"
            value=""
            placeholder="Enter a color"
            class="w-[100px] text-sm text-dark-grey"
          >

          <svn-button :disable="!colorInput" text="Save" class="!h-8" @click="changeColor" />
        </div>

        <div class="w-full flex justify-between">
          <div class="flex items-center gap-1">
            <svn-text sm medium>
              {{ 'Color: ' }}
            </svn-text>
  
            <span class="text-sm font-semibold uppercase" :style="{ color: color }">
              {{ color }}
            </span>
          </div>

          <div
            class="flex p-1 hover:bg-very-light-grey rounded cursor-pointer items-center justify-center !text-dark-grey hover:!text-fake-black"
            @click="clearColor"
          >
            <Icon icon="lucide:undo" height="20" width="20" />
          </div>          
        </div>
      </div> -->
    </PopoverPanel>
  </Popover>
</template>

<script setup>
import 'vanilla-colorful';
import { debounce } from 'lodash';
import { Editor } from '@tiptap/vue-3';
import { watch, ref, onMounted } from 'vue';
// import SvnText from '../../styles/SvnText.vue';
// import SvnButton from '../../button/SvnButton.vue';
import SvnProIconButton from '../../button/SvnProIconButton.vue';
import { Popover, PopoverButton, PopoverPanel } from '@headlessui/vue';
import { useTextMenuCommands as textMenuCommands } from '../hooks/useTextMenuCommands.js';

const props = defineProps({
  size: { type: String, default: null },
  editor: { type: Editor, default: null },
  pickerType: { type: String, default: null },
  icon: { type: String, default: 'custom:mingcute:text-color-line' },
})

onMounted(() => {
  editorRef.value = props.editor
});

const dialog = ref(false);
const editorRef = ref(null)
const color = ref('#000000')
const colorInput = ref(null)

const handleColorChanged = debounce((selectedColor) => {
  color.value = selectedColor
  if (props.pickerType === 'color') {
    textMenuCommands(editorRef.value)?.onChangeColor(color.value)
  } else {
    textMenuCommands(editorRef.value)?.onChangeHighlight(color.value)
  }
}, 300)

const changeColor = () => {
  let regex = new RegExp(/^#([A-Fa-f0-9]{6}|[A-Fa-f0-9]{3})$/)
  if (colorInput.value && regex.test(colorInput.value)) {
    color.value = colorInput.value

    if (props.pickerType === 'color') {
      textMenuCommands(editorRef.value)?.onChangeColor(color.value)
    } else {
      textMenuCommands(editorRef.value)?.onChangeHighlight(color.value)
    }
  }
}

const clearColor = () => {
  if (props.pickerType === 'color') {
    textMenuCommands(editorRef.value)?.onClearColor()
  } else {
    textMenuCommands(editorRef.value)?.onClearHighlight()
  }
}

watch(props, (newValue, oldValue) => {
  if (newValue.editor) {
    editorRef.value = props.editor
  }
});
</script>